package org.greenstone.gsdl3.gs3build.indexers;

import java.util.*;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.w3c.dom.Text;

import org.greenstone.gsdl3.gs3build.util.DOMUtils;
import org.greenstone.gsdl3.util.GSXML;

public abstract class AbstractIndexer implements IndexerInterface
{ 
  class CollectionIndex
  { String level;
    String name;
    List fields;

    public CollectionIndex(String indexName, Node node)
    { this.fields = new ArrayList();
      this.name = indexName;
      this.level = IndexerManager.DEFAULT_LEVEL;
    
      NodeList children = node.getChildNodes();
      for (int c = 0; c < children.getLength(); c ++) {
	Node child = children.item(c);
	
	if (child.getNodeType() == org.w3c.dom.Node.ELEMENT_NODE) {
	  String name = child.getNodeName();
	  
	  if (name.equals(GSXML.LEVEL_ELEM)) {
	    String levelName = DOMUtils.getNodeChildText(children.item(c));
	    this.level = levelName;
	  }
	  else if (name.equals(GSXML.FIELD_ELEM)) {
	    String fieldName = DOMUtils.getNodeChildText(children.item(c));
	    this.fields.add(fieldName.toString());
	  }
	}
      }
      if (this.fields.size() == 0) {
	this.fields.add(IndexerManager.DEFAULT_FIELD);
      }
    }

    public void prepareIndexer(IndexerInterface indexer)
      { //indexer.addIndex(this.name, this.level, this.fields.get(0).toString());
    }
  }


  public boolean configure(org.w3c.dom.Node searchNode)
  {
    NodeList indexChildren = searchNode.getChildNodes();

    // check for <index> tag children
    for (int i = 0; i < indexChildren.getLength(); i ++) {
      String childName = indexChildren.item(i).getNodeName();

      if (childName.equals(GSXML.INDEX_ELEM))
      { NamedNodeMap atts = indexChildren.item(i).getAttributes();
	
	Node attribute = atts.getNamedItem(GSXML.NAME_ATT);
	String indexName = attribute.getNodeValue();
	      
	// create the local indexer representation
	CollectionIndex index = new CollectionIndex(indexName, indexChildren.item(i));
	     
	// prepare it...
	index.prepareIndexer(this);
      }
    }
    return true;
  }

  public void tidyup()
  {
  }
}
